# coding: utf-8

"""
    Agilicus API

    Agilicus is API-first. Modern software is controlled by other software, is open, is available for you to use the way you want, securely, simply.  A rendered, online viewable and usable version of this specification is available at [api](https://www.agilicus.com/api). You may try the API inline directly in the web page. To do so, first obtain an Authentication Token (the simplest way is to install the Python SDK, and then run `agilicus-cli --issuer https://MYISSUER get-token`). You will need an org-id for most calls (and can obtain from `agilicus-cli --issuer https://MYISSUER list-orgs`). The `MYISSUER` will typically be `auth.MYDOMAIN`, and you will see it as you sign-in to the administrative UI.  This API releases on Bearer-Token authentication. To obtain a valid bearer token you will need to Authenticate to an Issuer with OpenID Connect (a superset of OAUTH2).  Your \"issuer\" will look like https://auth.MYDOMAIN. For example, when you signed-up, if you said \"use my own domain name\" and assigned a CNAME of cloud.example.com, then your issuer would be https://auth.cloud.example.com.  If you selected \"use an Agilicus supplied domain name\", your issuer would look like https://auth.myorg.agilicus.cloud.  For test purposes you can use our [Python SDK](https://pypi.org/project/agilicus/) and run `agilicus-cli --issuer https://auth.MYDOMAIN get-token`.  This API may be used in any language runtime that supports OpenAPI 3.0, or, you may use our [Python SDK](https://pypi.org/project/agilicus/), our [Typescript SDK](https://www.npmjs.com/package/@agilicus/angular), or our [Golang SDK](https://git.agilicus.com/pub/sdk-go).  100% of the activities in our system our API-driven, from our web-admin, through our progressive web applications, to all internals: there is nothing that is not accessible.  For more information, see [developer resources](https://www.agilicus.com/developer).   # noqa: E501

    The version of the OpenAPI document: 2021.05.03
    Contact: dev@agilicus.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from agilicus_api.configuration import Configuration


class AuthenticationAttribute(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'attribute_name': 'str',
        'internal_attribute_path': 'str'
    }

    attribute_map = {
        'attribute_name': 'attribute_name',
        'internal_attribute_path': 'internal_attribute_path'
    }

    def __init__(self, attribute_name=None, internal_attribute_path=None, local_vars_configuration=None):  # noqa: E501
        """AuthenticationAttribute - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._attribute_name = None
        self._internal_attribute_path = None
        self.discriminator = None

        self.attribute_name = attribute_name
        self.internal_attribute_path = internal_attribute_path

    @property
    def attribute_name(self):
        """Gets the attribute_name of this AuthenticationAttribute.  # noqa: E501

        The of the attribute in the relying party's schema. Case sensitive.  # noqa: E501

        :return: The attribute_name of this AuthenticationAttribute.  # noqa: E501
        :rtype: str
        """
        return self._attribute_name

    @attribute_name.setter
    def attribute_name(self, attribute_name):
        """Sets the attribute_name of this AuthenticationAttribute.

        The of the attribute in the relying party's schema. Case sensitive.  # noqa: E501

        :param attribute_name: The attribute_name of this AuthenticationAttribute.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and attribute_name is None:  # noqa: E501
            raise ValueError("Invalid value for `attribute_name`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                attribute_name is not None and len(attribute_name) > 511):
            raise ValueError("Invalid value for `attribute_name`, length must be less than or equal to `511`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                attribute_name is not None and not re.search(r'^[A-Za-z][A-Za-z0-9_]*$', attribute_name)):  # noqa: E501
            raise ValueError(r"Invalid value for `attribute_name`, must be a follow pattern or equal to `/^[A-Za-z][A-Za-z0-9_]*$/`")  # noqa: E501

        self._attribute_name = attribute_name

    @property
    def internal_attribute_path(self):
        """Gets the internal_attribute_path of this AuthenticationAttribute.  # noqa: E501

        The object path to a field to use as the attribute. If the value is not present, null or empty, the attribute will be omitted.   # noqa: E501

        :return: The internal_attribute_path of this AuthenticationAttribute.  # noqa: E501
        :rtype: str
        """
        return self._internal_attribute_path

    @internal_attribute_path.setter
    def internal_attribute_path(self, internal_attribute_path):
        """Sets the internal_attribute_path of this AuthenticationAttribute.

        The object path to a field to use as the attribute. If the value is not present, null or empty, the attribute will be omitted.   # noqa: E501

        :param internal_attribute_path: The internal_attribute_path of this AuthenticationAttribute.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and internal_attribute_path is None:  # noqa: E501
            raise ValueError("Invalid value for `internal_attribute_path`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                internal_attribute_path is not None and len(internal_attribute_path) > 511):
            raise ValueError("Invalid value for `internal_attribute_path`, length must be less than or equal to `511`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                internal_attribute_path is not None and not re.search(r'^([^\.]+\.?)*[^\.]+$', internal_attribute_path)):  # noqa: E501
            raise ValueError(r"Invalid value for `internal_attribute_path`, must be a follow pattern or equal to `/^([^\.]+\.?)*[^\.]+$/`")  # noqa: E501

        self._internal_attribute_path = internal_attribute_path

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AuthenticationAttribute):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AuthenticationAttribute):
            return True

        return self.to_dict() != other.to_dict()
